import { j as s } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as Ce, useState as J, useMemo as b, useRef as P, useEffect as ve, useCallback as Te } from "react";
import { isMobile as v } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as ze, Table as H, Skeleton as ke } from "antd";
import Me from "../../../node_modules/classnames/index.mjs";
import Le from "../../BitzDrawer/index.mjs";
import We from "../../BitzPagination/index.mjs";
import Pe from "../../BitzNoData/index.mjs";
import He, { TableContext as Ae } from "../Store/index.mjs";
import Oe from "../TableSkeleton/index.mjs";
import { columnSort as Q, genColumnKey as Y } from "../Store/utils/index.mjs";
import A from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import "../../BitzList/index.less.mjs";
import Ve from "../../BitzList/List.mjs";
import "../../BitzPullRefresh/style/index.less.mjs";
import Ee from "../../BitzPullRefresh/PullRefresh.mjs";
import Se from "../../../node_modules/lodash-es/at.mjs";
function _e({
  showPagination: w = !0,
  fillEvenRow: O = !0,
  evenRowBgColor: V = "#f9f9f9",
  height: m,
  dataSource: r = [],
  total: T = 0,
  columns: u,
  loading: N = !1,
  skeletonNum: Z = 2,
  skeletonRender: E,
  skeletonRowNum: I = 4,
  skeletonRowsWidth: ee = ["35%", "100%", "100%", "60%"],
  mobileLoadEmit: ne,
  mobileRefreshEmit: S,
  operationFilter: z,
  enableControlPage: se,
  pagination: le,
  paginationEmit: re = () => {
  },
  mobilePageHeight: $e = 500,
  mobileCancelText: te = "取消",
  noDataTitle: oe,
  noDataImg: ie,
  color: De,
  size: _,
  showTableTool: ae = !0,
  tableAction: ce,
  tableToolbar: he,
  selectionBar: de,
  scroll: a,
  resetPage: fe,
  ...c
}) {
  const { token: xe } = ze.useToken(), d = Ce(Ae), [be, k] = J(!1), ue = b(() => !!(r != null && r.length) && (r == null ? void 0 : r.length) >= T, [r, T]), [ge, pe] = J([]), ye = (e, n) => {
    var i;
    const l = (i = z == null ? void 0 : z(e, n)) == null ? void 0 : i.filter(
      (o) => o.type !== "divider"
    );
    l != null && l.length && (pe(l), k(!0));
  }, $ = () => {
    k(!1);
  }, je = (e) => {
    var n;
    k(!1), (n = e.onClick) == null || n.call(e);
  }, g = P(null), p = A(g), M = P(null), L = A(M), D = P(null), y = A(D), K = () => {
    var o;
    const e = (o = M.current) == null ? void 0 : o.querySelector(
      ".ant-table-body"
    ), n = e == null ? void 0 : e.clientWidth, l = ((e == null ? void 0 : e.offsetWidth) || 0) - n, i = l > 0;
    return { tbodyWidth: n, scrollBarWidth: l, hasScrollBar: i };
  }, we = (e) => {
    const n = e.length, l = e.filter((x) => x.width), o = l.map((x) => x.width).reduce((x, Be) => x + Be, 0);
    let h = 0;
    if (g.current) {
      const x = window.getComputedStyle(g.current);
      h = parseInt(x.getPropertyValue("--toolCell-width"));
    }
    let t = 0;
    c.rowSelection && (t += h), c.expandable && (t += h);
    const { tbodyWidth: C } = K(), f = parseInt(`${B.x}`) || 0, Ne = Math.max(f, C), G = (parseInt(`${Ne}`) || 0) - o - t;
    return G >= 0 ? G / (n - l.length) : void 0;
  }, { y: W, hasScrollBar: R } = b(() => {
    if (typeof m > "u")
      return {};
    const { hasScrollBar: e } = K();
    let n = 40, l = 40, i = 10;
    if (g.current) {
      const f = window.getComputedStyle(g.current);
      n = parseInt(f.getPropertyValue("--cell-block")), l = parseInt(f.getPropertyValue("--toolbar-height")), i = parseInt(f.getPropertyValue("--container-gap")) || 0;
    }
    const o = (y == null ? void 0 : y.height) || 0, h = o ? i : 0;
    return { y: m - o - h - l - n, hasScrollBar: e };
  }, [
    m,
    y == null ? void 0 : y.height,
    p == null ? void 0 : p.height,
    L == null ? void 0 : L.height
  ]), B = b(() => a != null && a.x ? { x: a.x, y: a.y || W } : a != null && a.y ? { x: 1e3, y: a.y } : { x: 1e3, y: W }, [a, W]), j = b(() => {
    const e = (h) => h.map((t) => {
      const C = Y(
        (t == null ? void 0 : t.key) || (t == null ? void 0 : t.dataIndex),
        t.index
      ), f = d.columnsMap[C];
      return f && f.show === !1 ? !1 : t.children ? {
        ...t,
        children: e(t.children)
      } : t;
    }).filter(Boolean), n = e(u);
    if (v)
      return n.sort(Q(d.columnsMap));
    const l = n.sort(Q(d.columnsMap)), i = we(l), o = l.map((h) => ({
      ...h,
      ...h.width ? {} : {
        // 给未设置width的列设置平均数
        width: i
      }
    }));
    return [H.SELECTION_COLUMN, H.EXPAND_COLUMN, ...o];
  }, [
    d.columnsMap,
    u,
    v,
    B.x,
    c.rowSelection,
    c.expandable,
    p == null ? void 0 : p.height
  ]);
  ve(() => {
    if (u && u.length > 0) {
      const e = u.map(
        (n) => (
          // @ts-ignore
          Y((n == null ? void 0 : n.key) ?? (n == null ? void 0 : n.dataIndex), n == null ? void 0 : n.dataIndex)
        )
      );
      d.setSortKeyColumns(e);
    }
  }, [u]);
  const U = b(() => `${_ ?? (d == null ? void 0 : d.tableSize) ?? "lg"}BitzTable`, [_, d.tableSize]), me = b(() => Me(
    "bitzTableContainer",
    /* "hideBorder", */
    { hasScrollBar: R },
    U
  ), [U, R]), X = b(() => ({
    "--evenRow-BgColor": V
    // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
  }), [
    V
    /** token.Table?.borderColor */
  ]), q = Te(
    (e, n) => O ? n % 2 === 0 ? "oddRow" : "evenRow" : "",
    [O]
  ), F = /* @__PURE__ */ s.jsx(
    Ve,
    {
      finished: ue,
      onLoad: ne,
      loadingText: "加载中...",
      finishedText: "没有更多了",
      errorText: "加载失败",
      children: /* @__PURE__ */ s.jsxs("div", { className: "mobileTable", children: [
        r == null ? void 0 : r.map((e, n) => /* @__PURE__ */ s.jsx(
          "div",
          {
            className: "mobileTableRow",
            onClick: () => ye(e, n),
            children: /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: j == null ? void 0 : j.map(
              (l, i) => {
                var o;
                return /* @__PURE__ */ s.jsx("div", { children: !(l != null && l.mobileHide) && /* @__PURE__ */ s.jsxs("div", { className: "row", children: [
                  !l.mobileHideLabel && /* @__PURE__ */ s.jsxs("div", { className: "label", children: [
                    `${l.title}`,
                    "："
                  ] }),
                  /* @__PURE__ */ s.jsx("div", { className: "value", children: ((o = l == null ? void 0 : l.render) == null ? void 0 : o.call(
                    l,
                    Se(e, (l == null ? void 0 : l.dataIndex) || ""),
                    e,
                    n
                  )) || (e == null ? void 0 : e[l.dataIndex]) })
                ] }) }, i);
              }
            ) })
          },
          n
        )),
        N && Array.from({ length: Z }).map((e, n) => /* @__PURE__ */ s.jsx("div", { className: "mobileTableRow", children: /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: E ? E() : /* @__PURE__ */ s.jsx(
          ke,
          {
            title: !1,
            paragraph: {
              rows: I,
              width: ee
            },
            active: !0
          }
        ) }) }, n))
      ] })
    }
  );
  return /* @__PURE__ */ s.jsxs("div", { className: "bitzTableBlock", children: [
    !v && /* @__PURE__ */ s.jsxs("div", { ref: g, className: me, style: { height: m }, children: [
      /* @__PURE__ */ s.jsxs("div", { className: "bitzTableContainerBody", ref: M, children: [
        ae && /* @__PURE__ */ s.jsxs("div", { className: "bitzTableToolbarBlock", children: [
          ce || /* @__PURE__ */ s.jsx("div", {}),
          he,
          (c == null ? void 0 : c.rowSelection) && /* @__PURE__ */ s.jsx(s.Fragment, { children: de })
        ] }),
        /* @__PURE__ */ s.jsx(
          H,
          {
            columns: j,
            dataSource: r,
            loading: !1,
            pagination: !1,
            scroll: B,
            ...c,
            style: X,
            rowClassName: q
          }
        ),
        /* @__PURE__ */ s.jsx(
          Oe,
          {
            columns: j,
            dataLength: r.length,
            scroll: B,
            rowSelection: c.rowSelection,
            expandable: c.expandable,
            style: X,
            rowClassName: q,
            loading: N
          }
        )
      ] }),
      w && /* @__PURE__ */ s.jsx(
        We,
        {
          elRefInstance: D,
          enableControl: se,
          pagination: le,
          total: T,
          dataSource: r,
          resetPage: fe,
          paginationEmit: re
        }
      )
    ] }),
    v && /* @__PURE__ */ s.jsxs(s.Fragment, { children: [
      (N || (r == null ? void 0 : r.length) > 0) && /* @__PURE__ */ s.jsx(s.Fragment, { children: S ? /* @__PURE__ */ s.jsx(Ee, { onRefresh: S, children: F }) : F }),
      !N && /* @__PURE__ */ s.jsx(Pe, { data: r, title: oe, img: ie }),
      /* @__PURE__ */ s.jsx(
        Le,
        {
          className: "tableMobileDrawer",
          open: be,
          placement: "bottom",
          height: "auto",
          closable: !1,
          onClose: $,
          children: /* @__PURE__ */ s.jsxs("div", { className: "drawerBox", children: [
            /* @__PURE__ */ s.jsx("div", { className: "boxBody", children: ge.map((e, n) => /* @__PURE__ */ s.jsx(
              "div",
              {
                className: "operaList",
                onClick: () => je(e),
                ...e.danger && {
                  style: { color: xe.colorError }
                },
                children: e.label
              },
              n
            )) }),
            /* @__PURE__ */ s.jsx("div", { className: "boxLine" }),
            /* @__PURE__ */ s.jsx("div", { className: "boxFooter", onClick: $, children: te })
          ] })
        }
      )
    ] })
  ] });
}
const on = (w) => (
  // @ts-ignore
  /* @__PURE__ */ s.jsx(He, { initValue: w, children: /* @__PURE__ */ s.jsx(_e, { ...w }) })
);
export {
  on as default
};
